"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LambdaExpressTemplate = exports.run = void 0;
var utils_package_1 = require("@goldstack/utils-package");
var utils_cli_1 = require("@goldstack/utils-cli");
var utils_terraform_1 = require("@goldstack/utils-terraform");
var configSchema_json_1 = __importDefault(require("./schemas/configSchema.json"));
var templateLambdaExpressConfig_1 = require("./templateLambdaExpressConfig");
var templateLambdaExpressDeploy_1 = require("./templateLambdaExpressDeploy");
var utils_terraform_aws_1 = require("@goldstack/utils-terraform-aws");
__exportStar(require("./templateS3Bucket"), exports);
__exportStar(require("./types/LambdaExpressPackage"), exports);
var yargs_1 = __importDefault(require("yargs"));
exports.run = function (args) { return __awaiter(void 0, void 0, void 0, function () {
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0: return [4 /*yield*/, utils_cli_1.wrapCli(function () { return __awaiter(void 0, void 0, void 0, function () {
                    var argv, config, command, opArgs;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                argv = utils_package_1.buildCli({
                                    yargs: yargs_1.default,
                                    deployCommands: utils_package_1.buildDeployCommands(),
                                    infraCommands: utils_terraform_1.infraCommands(),
                                }).help().argv;
                                config = templateLambdaExpressConfig_1.getConfig();
                                command = argv._[0];
                                opArgs = args.slice(3);
                                if (!(command === 'infra')) return [3 /*break*/, 2];
                                return [4 /*yield*/, utils_terraform_aws_1.terraformAwsCli(opArgs)];
                            case 1:
                                _a.sent();
                                return [2 /*return*/];
                            case 2:
                                if (!(command === 'deploy')) return [3 /*break*/, 4];
                                return [4 /*yield*/, templateLambdaExpressDeploy_1.deployCli(config, __spreadArrays(opArgs))];
                            case 3:
                                _a.sent();
                                return [2 /*return*/];
                            case 4: throw new Error('Unknown command: ' + command);
                        }
                    });
                }); })];
            case 1:
                _a.sent();
                return [2 /*return*/];
        }
    });
}); };
var LambdaExpressTemplate = /** @class */ (function () {
    function LambdaExpressTemplate() {
    }
    LambdaExpressTemplate.prototype.getTemplateName = function () {
        return 'lambda-express';
    };
    LambdaExpressTemplate.prototype.getJsonSchema = function () {
        return configSchema_json_1.default;
    };
    return LambdaExpressTemplate;
}());
exports.LambdaExpressTemplate = LambdaExpressTemplate;
//# sourceMappingURL=templateLambdaExpress.js.map